using System;
using System.Data;
using System.Configuration;
using System.IO; 
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using System.Xml;
using TuxWebService;
using System.Net;

public partial class _Default : System.Web.UI.Page 
{

    // Launcher Errors
    public const int LAUNCHER_ERROR_NOERROR             = 0x00000000;
    public const int LAUNCHER_ERROR_CONNECT             = 0x00000001;
    public const int LAUNCHER_ERROR_LOGON               = 0x00000002;
    public const int LAUNCHER_ERROR_LOGONPWDCHANGE      = 0x00000003;
    public const int LAUNCHER_ERROR_NETWORKERROR        = 0x00000004;
    public const int LAUNCHER_ERROR_OUTOFMEMORY         = 0x00000005;
    public const int LAUNCHER_ERROR_NOXML               = 0x00000006;
    public const int LAUNCHER_ERROR_NOCONTROLLER        = 0x00000007;
    public const int LAUNCHER_ERROR_NOSSL               = 0x00000008;
    public const int LAUNCHER_ERROR_INVALIDCERFIFICATE  = 0x00000009;

    public const int WEBSERVICE_ERROR_SETTINGSCHANGED   = 0x00000100;

    // New Authentication Errors
    public const int NEWAUTH_ERROR_SUCCESS = 0x00;
    public const int NEWAUTH_ERROR_SUCCESS_SERVEROTP = 0x01;
    public const int NEWAUTH_ERROR_CONN_FAILED = 0x02;
    public const int NEWAUTH_ERROR_MUST_CHANGE_PWD = 0x0D;
    public const int NEWAUTH_ERROR_CHANGEPWD_FAILED = 0x11;

    // New Authentication States
    public const int NA_STATE_INIT = 1;
    public const int NA_STATE_CONNECT = 2;
    public const int NA_STATE_IDENTIFY = 3;
    public const int NA_STATE_PROVIDELOGON = 4;
    public const int NA_STATE_PROVIDEACCINFO = 5;
    public const int NA_STATE_CHANGEPWD = 6;
    public const int NA_STATE_READY = 7;

    // New Authentication Method Types
    public const int NA_TYPE_OTP = 1;
    public const int NA_TYPE_OTPCC = 2;
    public const int NA_TYPE_PASSWORD = 3;

    // New Authentication Method Flags
    public const int NA_TOKEN_INACTIVE = 0x00000002;
    public const int NA_TOKEN_ACTIVATE_SMS = 0x00000004;
    public const int NA_TOKEN_ACTIVATE_EMAIL = 0x00000008;
    public const int NA_OTP_REQUEST_SMS = 0x00000010;
    public const int NA_OTP_REQUEST_EMAIL = 0x00000020;

    // Controller States
    public const int CONTROLLER_APPLIST_REPLY_SUCCESS = 0;
    public const int CONTROLLER_APPLIST_REPLY_SUCCESS_SERVEROTP = 1;
    public const int CONTROLLER_APPLIST_REPLY_NOTALLOWED = 4;

    public const int RET_CLIENT_USERPROPERTY_SUCCESS = 0;
    public const int RET_CLIENT_USERPROPERTY_FAILED = 1;
    public const int RET_CLIENT_USERPROPERTY_NEEDSAUTH = 2;
    
    protected void Page_Init(object sender, EventArgs e)
    {
        txtServiceUrl.Text = "http://localhost:" + Request.ServerVariables["SERVER_PORT"] + "/2XWebservice/2XWebService.asmx";        
    }

    protected void Page_Load(object sender, EventArgs e)
    {
    }

    protected void btnLogonTypeSelect_Click(object sender, EventArgs e)
    {
        //show/hide panels according to login type selection
        if (ddlLogonType.SelectedValue == "Basic Logon")
        {
            pnlBasicLogon.Visible = true;
            pnlNewAuthLogon.Visible = false;
        }
        else if (ddlLogonType.SelectedValue == "New Auth Logon")
        {
            pnlBasicLogon.Visible = false;
            pnlNewAuthLogon.Visible = true;
            txtNewAuthIP.Text = Request.ServerVariables["REMOTE_ADDR"];
            txtNewAuthLocalPort.Text = Request.ServerVariables["REMOTE_PORT"].ToString();
        }
    }

    protected void btnLogOn_Click(object sender, EventArgs e)
    {
        TUXWebServiceClass service = (TUXWebServiceClass)Session["current"];
        uint success = service.Logon(
            txtUserName.Text,
            txtPassword.Text,"127.0.0.1",
            //Context.Request.ServerVariables["REMOTE_ADDR"],
            txtFarmID.Text,
            false);

        Int16 nAppListLogon = (Int16)(success & 0x00FF); //Application listing logon result mask
        if (nAppListLogon == 0)
        {
            lblLoginResult.Text = "Login Successful";
            pnlRuntime.Visible = true;
            pnlBasicLogon.Enabled = false;
        }
        else lblLoginResult.Text = "Login Failed";

        updateConnModeLabel();
    }

    protected void btnNewAuthLogOn_Click(object sender, EventArgs e)
    {
        if (performLogin() == NA_STATE_READY)
        {
            RequestApplistFromPublishingAgent();

            pnlRuntime.Visible = true;
            pnlUserProperties.Visible = true;

            updateConnModeLabel();
        }

    }

    protected void btnGetFavourites_Click(object sender, EventArgs e)
    {
        if (performLogin() == NA_STATE_READY)
        {
            TUXWebServiceClass service = (TUXWebServiceClass)Session["current"];

            string reply = service.NewAuthGetFavourites();
            //reply has the following format: <xml> <error></error> <Favourites></Favourites> </xml>

            XmlDocument doc = new XmlDocument();
            doc.LoadXml(reply);
            XmlNodeReader xmlreader = new XmlNodeReader(doc);

            //Creating a Dataset
            DataSet myDataSet = new DataSet();
            myDataSet.ReadXml(xmlreader);

            if (myDataSet.Tables.Count > 0)
            {
                foreach (DataRow r in myDataSet.Tables[0].Rows)
                {
                    uint nError = RET_CLIENT_USERPROPERTY_SUCCESS;

                    if (r[0].ToString() != "")
                        nError = Convert.ToUInt32(r[0]);

                    switch (nError)
                    {
                        case RET_CLIENT_USERPROPERTY_SUCCESS:
                            {
                                if (myDataSet.Tables[0].Columns.Count > 1)
                                    lblGetFavourites.Text = "\"" + r[1].ToString() + "\"";
                                else
                                    lblGetFavourites.Text = "Error! Get Failed!";
                                break;
                            }
                        case RET_CLIENT_USERPROPERTY_NEEDSAUTH:
                            {
                                lblGetFavourites.Text = "Error! Needs Authentication!";
                                break;
                            }
                        default:
                        case RET_CLIENT_USERPROPERTY_FAILED:
                            {
                                lblGetFavourites.Text = "Error! Get Failed!";
                                break;
                            }
                    }
                }
            }
            uint nErrorCode = service.NewAuthFinalise();
        }
    }

    protected void btnUpdateFavourites_Click(object sender, EventArgs e)
    {
        if (performLogin() == NA_STATE_READY)
        {
            TUXWebServiceClass service = (TUXWebServiceClass)Session["current"];

            uint nError = service.NewAuthUpdateFavourites(txtUpdateFavourites.Text);
            switch (nError)
            {
                case RET_CLIENT_USERPROPERTY_SUCCESS:
                    {
                        lblUpdateFavourites.Text = "Updates Successfully!";
                        break;
                    }
                case RET_CLIENT_USERPROPERTY_NEEDSAUTH:
                    {
                        lblUpdateFavourites.Text = "Error! Needs Authentication!";
                        break;
                    }
                default:
                case RET_CLIENT_USERPROPERTY_FAILED:
                    {
                        lblUpdateFavourites.Text = "Error! Update Failed!";
                        break;
                    }
            }

            uint nErrorCode = service.NewAuthFinalise();
        }
    }

    private void updateConnModeLabel()
    {
        TUXWebServiceClass service = (TUXWebServiceClass)Session["current"];
        int mode = service.GetConnMode();
        switch (mode)
        {
            case 0: lblConnMode.Text = "Regular Gateway"; break;
            case 1: lblConnMode.Text = "Direct Mode"; break;
            case 2: lblConnMode.Text = "SSL Mode"; break;
        }

        cmbConnMode.SelectedIndex = mode;
    }

    protected void btnChangeMode_Click(object sender, EventArgs e)
    {
        TUXWebServiceClass service = (TUXWebServiceClass)Session["current"];
        service.SetConnMode(cmbConnMode.SelectedIndex);
        updateConnModeLabel();
    }

    protected void btnFarmFolders_Click(object sender, EventArgs e)
    {
        TUXWebServiceClass service = (TUXWebServiceClass)Session["current"];
        DataSet folders = service.GetFarmFolders();
        lblFarmFolders.Text = "<table border = 1><tr><td>ID</td><td>path</td></tr>";
        foreach (DataRow myRow in folders.Tables[0].Rows)
        {
            lblFarmFolders.Text += "<tr><td>"+myRow[0] + "</td><td>";
            lblFarmFolders.Text += myRow[1] + "</td></tr>";
        }
        lblFarmFolders.Text += "</table>";

        if (folders.Tables[0].Rows.Count > 0)
            txtFolderId.Text = folders.Tables[0].Rows[0][0].ToString();
    }

    protected void btnGetAppList_Click(object sender, EventArgs e)
    {
        TUXWebServiceClass service = (TUXWebServiceClass)Session["current"];
        string reply;
        if(txtFolderId.Text == "")
            reply = service.GetFullAppList();
        else
            reply = service.GetAppList(txtFolderId.Text);

        XmlDocument doc = new XmlDocument();
        doc.LoadXml(reply);
        XmlNodeReader xmlreader = new XmlNodeReader(doc);

        //treeview
        tvAppList.Nodes.Clear();
        tvAppList.Nodes.Add(new TreeNode(doc.DocumentElement.Name));
        TreeNode tNode = new TreeNode();
        tNode = (TreeNode)tvAppList.Nodes[0];
        //We make a call to addTreeNode, 
        //where we'll add all of our nodes
        addTreeNode(doc.DocumentElement, tNode);
        //Expand the treeview to show all nodes
        tvAppList.ExpandAll();
        //end treeview

        //Creating a Dataset
        DataSet myDataSet = new DataSet();
        myDataSet.ReadXml(xmlreader);

        lblAppList.Text = "<table border=1><tr><td>ID</td><td>Icon</td><td>Name</td><td>Description</td><td>Type</td></tr>";
        if (myDataSet.Tables.Count > 0)
        {
            foreach (DataRow r in myDataSet.Tables[0].Rows)
            {
                lblAppList.Text +="<tr><td>"+ r[3] + "</td><td>";
                lblAppList.Text += "<img src=\"GetIcon.ashx?id=" + r[3] + "\"/></td><td>";
                if (((string)r[0]) != "1")
                {
                    lblAppList.Text += "<a href=Get2xa.ashx?id=" + r[3] + ">" + r[1] + "</a></td><td>";
                    if (txtAppID.Text == String.Empty)
                    {
                        txtAppID.Text = r[3].ToString();
                        txt2xaappID.Text = r[3].ToString();
                    }
                }
                else
                {
                    lblAppList.Text += r[1] + "</td><td>";
                }
                lblAppList.Text += r[2] + "</td><td>";
                
                if(((string)r[0]) == "1")
                    lblAppList.Text += "Folder</td></tr>";
                else if (((string)r[0]) == "2")
                    lblAppList.Text += "Application</td></tr>";
                else if (((string)r[0]) == "3")
                    lblAppList.Text += "Desktop</td></tr>";
            }
        }
        lblAppList.Text += "</table>";
    }

    //This function is called recursively until all nodes are loaded
    private void addTreeNode(XmlNode xmlNode, TreeNode treeNode)
    {
        XmlNode xNode;
        TreeNode tNode;
        XmlNodeList xNodeList;
        if (xmlNode.HasChildNodes) //The current node has children
        {
            xNodeList = xmlNode.ChildNodes;
            for (int x = 0; x <= xNodeList.Count - 1; x++)
            //Loop through the child nodes
            {
                xNode = xmlNode.ChildNodes[x];
                treeNode.ChildNodes.Add(new TreeNode(xNode.Name));
                tNode = treeNode.ChildNodes[x];
                addTreeNode(xNode, tNode);
            }
        }
        else //No children, so add the outer xml (trimming off whitespace)
            treeNode.Text = xmlNode.OuterXml.Trim();
    }

    protected void btnGet2xa_Click(object sender, EventArgs e)
    {
        try
        {
            TUXWebServiceClass service = (TUXWebServiceClass)Session["current"];
            Response.Redirect("Get2xa.ashx?id="+txt2xaappID.Text);
        }
        catch{}
    }

    protected void btnGetURLSecure_Click(object sender, EventArgs e)
    {
        string folders = Request.ApplicationPath;

        Guid uniqueID = Guid.NewGuid();
        string server = Request.Url.Host;
        string port = Request.Url.Port.ToString();
        string bSSL = (Request.Url.Scheme.ToLower().CompareTo("http") == 0) ? "NO" : "YES";
        string path = folders + "/Get2xa.ashx?id=" + txt2xaappID.Text + "&app=2XClient&guid=" + uniqueID.ToString();
        string urlSchema = "tuxclient://?Command=Get2xa&Server=" + server + "&Port=" + port + "&Session=" + Session.SessionID + "&Secure=" + bSSL + "&Path=" + HttpUtility.UrlEncode(path);
        AdvancedUrlSchemaDIV.InnerHtml = "<a href=\"" + urlSchema + "\">" + urlSchema + "</a>";

    }

    protected void btnGetURLSchema_Click(object sender, EventArgs e)
    {
        TUXWebServiceClass service = (TUXWebServiceClass)Session["current"];
        string urlSchema = service.GetURLSchema(txt2xaappID.Text);
        UrlSchemaDIV.InnerHtml = "<a href=\"" + urlSchema + "\">" + urlSchema + "</a>";
    }

    protected String GetDetectionPath()
    {
        return HttpUtility.UrlEncode(Request.ApplicationPath + "/Detection.aspx?app=2XClient&installed=1");
    }

    protected String GetbSSL()
    {
        string bSSL = (Request.Url.Scheme.ToLower().CompareTo("http") == 0) ? "NO" : "YES";
        return bSSL;
    }

    protected void btnGetImage_Click(object sender, EventArgs e)
    {
        TUXWebServiceClass service = (TUXWebServiceClass)Session["current"];
        string reply = service.GetImage(txtAppID.Text);
        
        byte[] iconbin = Convert.FromBase64String(reply);
        System.IO.MemoryStream memStream = new System.IO.MemoryStream(iconbin);
        imgImage.ImageUrl = "GetIcon.ashx?id=" + txtAppID.Text;
        imgImage.Visible = true;
    }

    protected void btnLogOut_Click(object sender, EventArgs e)
    {
        TUXWebServiceClass service = (TUXWebServiceClass)Session["current"];
        service.Logoff();
        lblLoginResult.Text = String.Empty;
        lblAppList.Text = String.Empty;
        lblFarmFolders.Text = String.Empty;

        pnlLogonType.Enabled = true;
        pnlRuntime.Visible = false;
    }

    protected void btnAccept_Click(object sender, EventArgs e)
    {
        try
        {
            TUXWebServiceClass service = new TUXWebServiceClass();
            service.Url = txtServiceUrl.Text;

            //make sure session remains the same when switching pages
            service.CookieContainer = new System.Net.CookieContainer();
            Session["current"] = service;

            //get Module Version
            string reply = service.GetModulesVersion();
            XmlDocument doc = new XmlDocument();
            doc.LoadXml(reply);

            lblVersion.Text = "Application Listing : ";
            lblVersion.Text += doc.SelectSingleNode("/ModulesVer/AppList").InnerText;
            lblVersion.Text += "<br>Web Server : ";
            lblVersion.Text += doc.SelectSingleNode("/ModulesVer/WebServer").InnerText;
            lblVersion.Text += "<br>WebPortal Sample : ";

            string fileVersion = Request.ServerVariables["APPL_PHYSICAL_PATH"] + "Version.txt";
            StreamReader sr = new StreamReader(new FileStream(fileVersion, FileMode.Open, FileAccess.Read));
            lblVersion.Text += sr.ReadLine();


            //getting list of available farms
            DataSet farms = service.GetListOfFarms();

            lblFarms.Text = "<table border = 1><tr><td>ID</td><td>Alias</td><td>Server Name</td></tr>";
            foreach (DataRow myRow in farms.Tables[0].Rows)
            {
                lblFarms.Text += "<tr><td>" + myRow[0] + "</td><td>";
                lblFarms.Text += myRow[1] + "</td><td>";
                lblFarms.Text += myRow[2] + "</td></tr>";
            }
            lblFarms.Text += "</table>";
            
            if (farms.Tables[0].Rows.Count > 0)
                txtFarmID.Text = farms.Tables[0].Rows[0][0].ToString();


            pnlPreLog.Visible = false;
            pnlLogonType.Visible = true;
            pnlDetails.Visible = true;

            lblWebserviceError.Text = string.Empty;
        }
        catch
        {
            Session["current"] = null;
            lblWebserviceError.Text = "Unable to find webservice";
        }
    }

    protected void ShowLogonPanel()
    {
        TUXWebServiceClass service = (TUXWebServiceClass)Session["current"];

        String Methods = "";
        Methods = service.NewAuthGetLogonMethods();

        XmlDocument xml = new XmlDocument();
        xml.LoadXml(Methods);

        XmlNode methodsNode = xml.SelectSingleNode("descendant::Data");

        if (methodsNode != null)
        {
            System.Collections.IEnumerator theChildren = methodsNode.GetEnumerator();
            int cnt = 0;

            ddlNewAuthSelectedMethod.Items.Clear();
            ddlNewAuthSelectedMethod.Enabled = true;

            while (theChildren.MoveNext())
            {
                XmlNode thisChild = (XmlNode)theChildren.Current;
                ddlNewAuthSelectedMethod.Items.Add(thisChild.InnerText);

                int nType = service.NewAuthGetMethodType(cnt);

                switch (nType)
                {
                    case NA_TYPE_OTP:
                        txtNewAuthOTP.Enabled = true;
                        break;

                    case NA_TYPE_OTPCC:
                        txtNewAuthOTP.Enabled = true;
                        txtNewAuthOTPCC.Enabled = true;
                        txtNewAuthOTPCC.Text = service.NewAuthGetChallengeCode(cnt);
                        break;

                    case NA_TYPE_PASSWORD:
                        txtNewAuthPassword.Enabled = true;
                        break;
                }

                uint uMethodFlags = service.NewAuthGetMethodFlags(cnt);

                if ((uMethodFlags & NA_TOKEN_INACTIVE) == NA_TOKEN_INACTIVE)
                {
                    lblNewAuthIdentifyMessage.Text = "Needs to Activate!";
                }
                else if ((uMethodFlags & NA_OTP_REQUEST_EMAIL) == NA_OTP_REQUEST_EMAIL ||
                         (uMethodFlags & NA_OTP_REQUEST_SMS) == NA_OTP_REQUEST_SMS)
                {
                    btnNewAuthSendOTP.Enabled = true;
                    ddlNewAuthSend.Enabled = true;
                    if ((uMethodFlags & NA_OTP_REQUEST_EMAIL) == NA_OTP_REQUEST_EMAIL)
                    {
                        ddlNewAuthSend.SelectedValue = "SMTP";
                    }
                    else
                    {
                        ddlNewAuthSend.Items.FindByValue("SMTP").Enabled = false;
                    }
                    if ((uMethodFlags & NA_OTP_REQUEST_SMS) == NA_OTP_REQUEST_SMS)
                    {
                        if (!((uMethodFlags & NA_OTP_REQUEST_EMAIL) == NA_OTP_REQUEST_EMAIL))
                            ddlNewAuthSend.SelectedValue = "SMS";
                        else
                            lblNewAuthIdentifyMessage.Text = "Also have the option to send by SMS";
                    }
                    else
                    {
                        ddlNewAuthSend.Items.FindByValue("SMS").Enabled = false;
                    }
                }
                else
                {
                    btnNewAuthSendOTP.Enabled = false;
                }

                cnt++;
            }
        }
    }

    protected void btnNewAuthSendOTP_Click(object sender, EventArgs e)
    {
        TUXWebServiceClass service = (TUXWebServiceClass)Session["current"];

        if (service == null)
            return;

        if (!service.NewAuthSendCredentials(ddlNewAuthSelectedMethod.Text, ddlNewAuthSend.SelectedValue))
        {
            lblNewAuthIdentifyMessage.Text = service.NewAuthGetReplyErrorMsg();
            return;
        }

        lblNewAuthIdentifyMessage.Text = service.NewAuthGetReplyErrorMsg();
    }

    protected void ShowAccInfoPanel()
    {
        TUXWebServiceClass service = (TUXWebServiceClass)Session["current"];

        pnlNewAuthNewUser.Visible = true;
        txtNewAuthNewUserUsername.Text = txtNewAuthUsername.Text;
        txtNewAuthNewUserUsername.Enabled = false;

        if (service == null)
            return;

        String xmlData = service.NewAuthGetAccountInfo();

        XmlDocument xml = new XmlDocument();
        xml.LoadXml(xmlData);

        XmlNode node;

        node = xml.SelectSingleNode("descendant::Username");
        if (node != null)
        {
            txtNewAuthNewUserUsername.Text = node.InnerText;
        }

        node = xml.SelectSingleNode("descendant::FullName");
        if (node != null)
        {
            txtNewAuthNewUserFullname.Text = node.InnerText;
        }

        node = xml.SelectSingleNode("descendant::Mobile");
        if (node != null)
        {
            txtNewAuthNewUserMobile.Text = node.InnerText;
        }

        node = xml.SelectSingleNode("descendant::Email");
        if (node != null)
        {
            txtNewAuthNewUserEmail.Text = node.InnerText;
        }
    }

    protected void btnNewAuthNewUserAdd_Click(object sender, EventArgs e)
    {
        TUXWebServiceClass service = (TUXWebServiceClass)Session["current"];

        if (Session.IsNewSession)
            return;

        if (service == null || service.NewAuthWhatsNext() != NA_STATE_PROVIDEACCINFO)
            return;

        bool isValid = service.NewAuthCreateAccount(txtNewAuthNewUserFullname.Text, txtNewAuthNewUserMobile.Text, txtNewAuthNewUserEmail.Text);
        if (isValid)
        {
            if (service.NewAuthGetMethodName(0) == "GridID")
            {
                String clientGrid = service.NewAuthGetClientGrid();
                clientGrid = clientGrid.Replace("\n", "<br />");
                if (clientGrid == "")
                {
                    lblNewAuthNewUserMessage.Text = service.NewAuthGetReplyErrorMsg();
                    return;
                }

                String serverGrid = service.NewAuthGetServerGrid();
                serverGrid = serverGrid.Replace("\n", "<br />");

                String innerHTML;
                innerHTML = "<html><head><title>Parallels RAS Web Portal</title></head>";
                innerHTML += "<body><pre><span class=gridFormat>";
                innerHTML += "<h1>Client Grid</h1>" + clientGrid;

                if (serverGrid.Length > 0)
                    innerHTML += "<br /><br /><h1>Server Grid</h1>" + serverGrid;

                innerHTML += "</span></pre></body></html>";

                String fn;
                fn = "var newWindow;";
                fn += "newWindow = window.open('', '_blank', 'height=490,width=450,status=no,toolbar=no,menubar=no,location=no,resizable=no,scrollbars=yes');";
                fn += "newWindow.document.body.innerHTML = '" + innerHTML + "';";

                //userLogon.setShowGridFN = fn;
                lblNewAuthNewUserMessage.Text = innerHTML;
            }

            if (performLogin() == NA_STATE_READY)
            {
                RequestApplistFromPublishingAgent();
            }
            else
            {
                pnlNewAuthActivate.Visible = true;
                pnlNewAuthNewUser.Visible = false;
            }
            ReAssignActChannels();
        }
        else
        {
            lblNewAuthNewUserMessage.Text = service.NewAuthGetReplyErrorMsg();
        }
    }

    private void ReAssignActChannels()
    {
        TUXWebServiceClass service = (TUXWebServiceClass)Session["current"];

        String Methods = service.NewAuthGetLogonMethods();

        XmlDocument xml = new XmlDocument();
        xml.LoadXml(Methods);
        XmlNode methodsNode = xml.SelectSingleNode("descendant::Data");

        int cnt = 0;
        if (methodsNode != null)
        {
            System.Collections.IEnumerator theChildren = methodsNode.GetEnumerator();
            while (theChildren.MoveNext())
            {
                XmlNode thisChild = (XmlNode)theChildren.Current;
                if (thisChild.InnerText == ddlNewAuthSelectedMethod.SelectedValue)
                    break;
                cnt++;
            }

        }

        uint uMethodFlags = service.NewAuthGetMethodFlags(cnt);
        if ((uMethodFlags & NA_TOKEN_ACTIVATE_EMAIL) != NA_TOKEN_ACTIVATE_EMAIL)
        {
            ddlNewAuthActSend.Items.FindByValue("SMTP").Attributes.Add("disabled", "true");
            ddlNewAuthActSend.Items.FindByValue("SMTP").Selected = false;
        }
        else
        {
            ddlNewAuthActSend.Items.FindByValue("SMTP").Attributes.Remove("disabled");
            ddlNewAuthActSend.Items.FindByValue("SMTP").Selected = true;
        }
        if ((uMethodFlags & NA_TOKEN_ACTIVATE_SMS) != NA_TOKEN_ACTIVATE_SMS)
        {
            ddlNewAuthActSend.Items.FindByValue("SMS").Attributes.Add("disabled", "true");
            ddlNewAuthActSend.Items.FindByValue("SMS").Selected = false;
        }
        else
        {
            ddlNewAuthActSend.Items.FindByValue("SMS").Attributes.Remove("disabled");
            if ((uMethodFlags & NA_TOKEN_ACTIVATE_EMAIL) != 0)
                ddlNewAuthActSend.Items.FindByValue("SMS").Selected = false;
            else
                ddlNewAuthActSend.Items.FindByValue("SMS").Selected = true;
        }
    }

    protected void btnNewAuthActivate_Click(object sender, EventArgs e)
    {
        TUXWebServiceClass service = (TUXWebServiceClass)Session["current"];

        if (Session.IsNewSession)
            return;

        if (service == null)
            return;

        if (!service.NewAuthActivateToken(ddlNewAuthSelectedMethod.Text, txtNewAuthActCode.Text))
        {
            lblNewAuthActMessage.Text = service.NewAuthGetReplyErrorMsg();
            ReAssignActChannels();
            return;
        }

        pnlNewAuthActivate.Visible = false;

        if (performLogin() == NA_STATE_READY)
        {
            RequestApplistFromPublishingAgent();
        }
    }

    protected void btnNewAuthActSend_Click(object sender, EventArgs e)
    {
        TUXWebServiceClass service = (TUXWebServiceClass)Session["current"];

        if (Session.IsNewSession)
            return;

        if (service == null)
            return;

        if (!service.NewAuthSendActCode(ddlNewAuthSelectedMethod.Text, ddlNewAuthActSend.SelectedValue))
        {
            lblNewAuthActMessage.Text = service.NewAuthGetReplyErrorMsg();
            return;
        }

        lblNewAuthActMessage.Text = service.NewAuthGetReplyErrorMsg();

        ReAssignActChannels();
    }

    protected uint performLogin()
    {

        bool bReIdentify = false;
        bool bSecure = Convert.ToBoolean(txtNewAuthSecure.Text);

        TUXWebServiceClass service = (TUXWebServiceClass)Session["current"];

        string userIP = txtNewAuthIP.Text;
        int localPort = Convert.ToInt32(txtNewAuthLocalPort.Text);
        string username = txtNewAuthUsername.Text;
        string password = txtNewAuthPassword.Text;
        string farmID = txtNewAuthFarmID.Text;
        string lang = txtNewAuthLang.Text;

        String otp = txtNewAuthOTP.Text;
        String SelectedMethod = ddlNewAuthSelectedMethod.SelectedValue;
        
        bool bAskWhatIsNext;
        
        if (bReIdentify)
            //If it failes state is reset to NA_STATE_INIT
            service.NewAuthDoIdentify(username, userIP, localPort);

        uint nWhatisNext;
        do
        {
            bAskWhatIsNext = false;

            //check what is the next step
            nWhatisNext = service.NewAuthWhatsNext();

            switch (nWhatisNext)
            {
                default:
                case NA_STATE_INIT:
                case NA_STATE_CONNECT:
                case NA_STATE_IDENTIFY:
                    {
                        //Perform NewAuthLogon   
                        int nError = (int)service.NewAuthLogon(username, userIP, localPort, farmID, bSecure, lang, true);
                        if (nError == WEBSERVICE_ERROR_SETTINGSCHANGED)
                        {
                            lblNewAuthIdentifyMessage.Text = "error: " + WEBSERVICE_ERROR_SETTINGSCHANGED + " - settings changed";
                            return nWhatisNext;
                        }
                        else if (nError == NEWAUTH_ERROR_CONN_FAILED)
                        {
                            lblNewAuthIdentifyMessage.Text =  service.NewAuthGetReplyErrorMsg();
                        }
                        else if (nError != NEWAUTH_ERROR_SUCCESS)
                        {
                            lblNewAuthIdentifyMessage.Text = service.NewAuthGetReplyErrorMsg();
                        }
                        else
                        {
                            bAskWhatIsNext = true; // Go to next state
                        }
                        break;
                    }
                case NA_STATE_PROVIDELOGON:
                    {
                        bool bSuccess = false;

                        String nextMethodName = service.NewAuthGetMethodName(0);
                        if (nextMethodName == "Windows") // Perform windows Logon
                        {
                            SelectedMethod = "Windows";
                            if (username.Length != 0 && password.Length != 0)
                            {
                                uint nRet = service.NewAuthSetLogonMethod("Windows", password);

                                bSuccess = (nRet == NEWAUTH_ERROR_SUCCESS || nRet == NEWAUTH_ERROR_MUST_CHANGE_PWD);
                                if (!bSuccess)
                                {
                                    lblNewAuthIdentifyMessage.Text = service.NewAuthGetReplyErrorMsg();
                                }
                            }
                        }
                        else
                        {
                            //Second Level Authentication
                            if (SelectedMethod.Length != 0 && otp.Length != 0)
                            {
                                uint iRet = service.NewAuthSetLogonMethod("QuickID", otp);

                                if (iRet == NEWAUTH_ERROR_SUCCESS || iRet == NEWAUTH_ERROR_SUCCESS_SERVEROTP)
                                {
                                    if (iRet == NEWAUTH_ERROR_SUCCESS_SERVEROTP)
                                    {
                                        lblNewAuthIdentifyMessage.Text = service.NewAuthGetReplyErrorMsg();
                                    }

                                    bSuccess = true;
                                }
                                else
                                {
                                    lblNewAuthIdentifyMessage.Text = service.NewAuthGetReplyErrorMsg();
                                }
                            }
                        }

                        if (bSuccess)
                        {
                            bAskWhatIsNext = true;
                            lblNewAuthMessage.Text = "New Auth Logon Successful";
                        }
                        else
                        {
                            ShowLogonPanel();
                            lblNewAuthMessage.Text = "New Auth Logon in process...";
                        }

                        break;
                    }
                case NA_STATE_PROVIDEACCINFO:
                    {
                        ShowAccInfoPanel();
                        break;
                    }
                case NA_STATE_CHANGEPWD:
                    {
                        lblNewAuthIdentifyMessage.Text = service.NewAuthGetReplyErrorMsg();
                        //ShowChangePwdPanel();
                        break;
                    }
                case NA_STATE_READY:
                    {
                        break;
                    }
            }
        } while (bAskWhatIsNext == true);

        return nWhatisNext;
    }

    protected void RequestApplistFromPublishingAgent()
    {
        TUXWebServiceClass service = (TUXWebServiceClass)Session["current"];
        try
        {
            uint nErrorCode = service.NewAuthSaveAppList();
            if (nErrorCode == CONTROLLER_APPLIST_REPLY_NOTALLOWED)
            {
                lblNewAuthMessage.Text = service.GetAppListErrorMsg();
            }

            service.NewAuthFinalise();
        }
        catch (Exception ex)
        {
            string msg = ex.Message + "\n";
            msg += ex.InnerException + "\n";
            msg += ex.StackTrace + "\n";
        }
    }
}
    
