<%@ WebHandler Language="C#" Class="Get2xa" %>

using System;
using System.Web;
using System.Web.SessionState;
using System.Web.Services.Protocols;
using TuxWebService;

public class Get2xa : IHttpHandler, IReadOnlySessionState
{
    //In the case of get 2xa URL Schema, the Parallels Client will connect with this page to get the full 2xa file (this is configured in the path parameter of the url schema).
    
    public void ProcessRequest (HttpContext Context) 
    {
        //The use of the IIS Session ID is useful so that the current session details and logins will still be available.
        TUXWebServiceClass appListClass = (TUXWebServiceClass)Context.Session["current"];
        if (appListClass != null)
        {
            HttpCachePolicy plc = Context.Response.Cache;
            plc.SetNoStore();
            
            //setting the header and contect type of the respons, which will contain the 2xa file
            Context.Response.AddHeader("Content-Disposition", String.Format("attachment; filename=App{0}.2xa", Context.Request["id"]));
            Context.Response.ContentType = "application/x-2xa";

            try
            {
                //getting the 2xa file by the application id, that was set as one of the querystrings in the 'path' parameter of the url schema, from the Web Service.
                string TUXappData = appListClass.Get2XA(Context.Request["id"]);
                if (TUXappData.Length > 0)
                {
                     Context.Response.Write(TUXappData);
                }
            }
            catch
            {
                Context.Response.Redirect("Default.aspx");
            }
        }
        else
        {
            Context.Response.Redirect("Default.aspx");
        }
    }
 
    public bool IsReusable 
    {
        get 
        {
            return false;
        }
    }

}
